#ifndef _MAINDLG_CPP
#define _MAINDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <CommCtrl.H>
#include <ShlOBJ.H>
#include <Stdlib.H>
#include <Mmsystem.h>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Package.H"
#include "../Source/Entry.H"
#include "../Source/Common.H"
#include "../Source/DragDrop.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/ReadingDlg.H"
#include "../Dialogs/PackingDlg.H"
#include "../Dialogs/ExtractDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/RegistrationDlg.H"
#include "../Dialogs/FileInfoDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND MainDialog_hWnd = NULL;
HWND hFileList = NULL;
HWND hHorizBar = NULL;
HWND hStatusBar = NULL;

HWND hTB_New = NULL;
HWND hTB_Open = NULL;
HWND hTB_AddFiles = NULL;
HWND hTB_Delete = NULL;
HWND hTB_Extract = NULL;
//HWND hTB_View = NULL;
HWND hTB_Info = NULL;
HWND hTB_Config = NULL;
HWND hTB_Find = NULL;
HWND hTB_Exit = NULL;

HIMAGELIST hImageList = NULL;

int iSortCol = -1;
int iSortUpOrDown = -1;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define SORT_UP        1
#define SORT_DOWN      2

#define COL_STRING     1
#define COL_INTEGER    2
#define COL_DOUBLE     3
#define COL_DATE       4

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CALLBACK CompListEx(LPARAM lParam1, LPARAM lParam2, LPARAM lParam3)
{
    char buf1[MAX_PATH];
    char buf2[MAX_PATH];

    int RetVal = 0;

    SORTDATA *lpsd;

    lpsd = (SORTDATA *)lParam3;

    ListView_GetItemText(lpsd->hwndList, lParam1, (int)lpsd->isortSubItem, buf1, sizeof(buf1));
    ListView_GetItemText(lpsd->hwndList, lParam2, (int)lpsd->isortSubItem, buf2, sizeof(buf2));

    if(lpsd->iColType == COL_STRING)
    {
        RetVal = _strcmpi(buf1, buf2);
    }
    else if(lpsd->iColType == COL_INTEGER)
    {
        int Val1 = iFormattedValue(buf1);
        int Val2 = iFormattedValue(buf2);

        if(Val1 > Val2)
            RetVal = 1;
        else if(Val1 < Val2)
            RetVal = -1;
        else return 0;
    }
    else if(lpsd->iColType == COL_DOUBLE)
    {
        double Val1 = fFormattedValue(buf1);
        double Val2 = fFormattedValue(buf2);

        if(Val1 > Val2)
            RetVal = 1;
        else if(Val1 < Val2)
            RetVal = -1;
        else return 0;
    }

    if(RetVal == 0)
        return 0;

    if(lpsd->iUPDOWN == SORT_DOWN)
    {
        if(RetVal == 1)
            return -1;
        else return 1;
    }
    else return RetVal;

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CALLBACK CompList(LPARAM lParam1, LPARAM lParam2, LPARAM lParam3)
{
    int RetVal = 0;
    SORTDATA *lpsd;

    lpsd = (SORTDATA *)lParam3;

    if(lParam1 > lParam2)
        RetVal = 1;
    else if(lParam1 < lParam2)
        RetVal = -1;
    else return 0;

    if(lpsd->iUPDOWN == SORT_DOWN)
    {
        if(RetVal == 1)
            return -1;
        else return 1;
    }
    else return RetVal;

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool DeletePostExecute(const char *sPath, const char *sParam)
{
	PROCESS_INFORMATION PI;
	STARTUPINFO SI;

	unsigned long ulExitCode = 0;

	DWORD dwDfltStrSz = 0;

	char sExe[MAX_PATH * 3];
	char sExeTmp[MAX_PATH * 3];
	char sExt[MAX_PATH];
	char sRegTemp[1024];
	char sFileAsso[1024];
	char sSystemRoot[1024];

	memset(sFileAsso, 0, sizeof(sFileAsso));

	_splitpath_s(sParam, NULL, 0, NULL, 0, NULL, 0, sExt, sizeof(sExt));

	dwDfltStrSz = sizeof(sFileAsso);
	memset(sFileAsso, 0, dwDfltStrSz);
	if(Get_StringRegistryValue(HKEY_CLASSES_ROOT, sExt, NULL, sFileAsso, dwDfltStrSz))
	{
		strcat_s(sFileAsso, sizeof(sFileAsso), "\\Shell");
		
		dwDfltStrSz = sizeof(sRegTemp);
		memset(sRegTemp, 0, dwDfltStrSz);
		if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, sFileAsso, NULL, sRegTemp, dwDfltStrSz))
		{
			//There is no default shell command.

			HKEY hKey = NULL;

			//Open the sExt\Shell key.
			if(RegOpenKeyEx(HKEY_CLASSES_ROOT, sFileAsso, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
			{
				//Get the first key name.
				dwDfltStrSz = sizeof(sRegTemp);
				memset(sRegTemp, 0, dwDfltStrSz);
				if(RegEnumKeyEx(hKey, 0, sRegTemp, &dwDfltStrSz, NULL, NULL, NULL, NULL) == ERROR_SUCCESS)
				{
					RegCloseKey(hKey);
				}
				else{
					//There are no sub keys, there is no program associated with this sExt.
					RegCloseKey(hKey);
					return false;
				}
			}
		}

		if(strlen(sFileAsso) == 0)
		{
			return false;
		}

		strcat_s(sFileAsso, sizeof(sFileAsso), "\\");
		strcat_s(sFileAsso, sizeof(sFileAsso), sRegTemp);
		strcat_s(sFileAsso, sizeof(sFileAsso), "\\Command");

		dwDfltStrSz = sizeof(sExe);
		memset(sExe, 0, dwDfltStrSz);
		if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, sFileAsso, NULL, sFileAsso, dwDfltStrSz))
		{
			return false;
		}

		LCase(sFileAsso);

		Get_SystemDirectoryEx(sSystemRoot);
		
		ReplaceStrings(sFileAsso, "%systemroot%", sSystemRoot, sExeTmp);
		ReplaceStrings(sExeTmp, "%1", sParam, sExe);


	}

    //Set StartupInfo for the spawned process.
	GetStartupInfo(&SI);        

    SI.dwFlags     = STARTF_USESHOWWINDOW;
    SI.wShowWindow = SW_SHOWNORMAL;

	BOOL bResult = CreateProcess(NULL, sExe, NULL, NULL, TRUE, CREATE_SUSPENDED, NULL, sPath, &SI, &PI);

    if(bResult)
	{
		ResumeThread(PI.hThread);
        
		do
		{
			GetExitCodeProcess(PI.hProcess, &ulExitCode); 
			Sleep(1);
		}while(ulExitCode == STILL_ACTIVE);

	}

	DeleteFile(sParam); //FIXME: This should be a secure delete.

	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Sink(HWND hWnd)
{
	DWORD dwStyle = GetWindowLong(hWnd, GWL_EXSTYLE);

	if(!(dwStyle & WS_EX_CLIENTEDGE))
	{
		SetWindowLong(hWnd, GWL_EXSTYLE, dwStyle | WS_EX_CLIENTEDGE);
		SetWindowPos(hWnd, NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_FRAMECHANGED);
	}
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Float(HWND hWnd)
{
	DWORD dwStyle = GetWindowLong(hWnd, GWL_EXSTYLE);

	if((dwStyle & WS_EX_CLIENTEDGE))
	{
		SetWindowLong(hWnd, GWL_EXSTYLE, dwStyle & ~WS_EX_CLIENTEDGE);
		SetWindowPos(hWnd, NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_FRAMECHANGED);
	}

	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void OnMouseOver(HWND hWnd)
{
	if(IsMouseOverHwnd(hWnd) && (MainDialog_hWnd == GetForegroundWindow()))
	{
		Sink(hWnd);
	}
	else{
		Float(hWnd);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void AlignText(HWND hBut, HWND hTxt)
{
    RECT rcBut;

    GetWindowRect(hBut, &rcBut);

    SetWindowPos(hTxt, NULL, rcBut.left - 3, 57, 50, 18, SWP_NOZORDER);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI MouseOverThread(LPVOID lpData)
{
	while(1)
	{
		OnMouseOver(hTB_New);
		OnMouseOver(hTB_Open);
		OnMouseOver(hTB_AddFiles);
		OnMouseOver(hTB_Delete);
		OnMouseOver(hTB_Extract);
		//OnMouseOver(hTB_View);
		OnMouseOver(hTB_Info);
		OnMouseOver(hTB_Config);
		OnMouseOver(hTB_Find);
		OnMouseOver(hTB_Exit);
		Sleep(100);
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK MainDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HWND hTBNew = NULL;

	static bool bDragging = false;
	static bool bFirst = false;

	static HIMAGELIST hDragImageList;

	//--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        MainDialog_hWnd = hWnd;

		CreateThread(NULL, 0, MouseOverThread, (LPVOID) gsArchiveName, 0, NULL);

		HMENU hSysMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(hSysMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(hSysMenu, MF_STRING, 1000, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

		hTB_New      = GetDlgItem(hWnd, IDI_TB_NEW);
		hTB_Open     = GetDlgItem(hWnd, IDI_TB_OPEN);
		hTB_AddFiles = GetDlgItem(hWnd, IDI_TB_ADDFILES);
		hTB_Delete   = GetDlgItem(hWnd, IDI_TB_DELETE);
		hTB_Extract  = GetDlgItem(hWnd, IDI_TB_EXTRACT);
		//hTB_View     = GetDlgItem(hWnd, IDI_TB_VIEW);
		hTB_Info     = GetDlgItem(hWnd, IDI_TB_INFO);
		hTB_Config   = GetDlgItem(hWnd, IDI_TB_CONFIG);
		hTB_Find     = GetDlgItem(hWnd, IDI_TB_FIND);
		hTB_Exit     = GetDlgItem(hWnd, IDI_TB_EXIT);
		hHorizBar	 = GetDlgItem(hWnd, IDC_HORIZBAR);
		hFileList	 = GetDlgItem(hWnd, IDC_FILELIST);

		int iInc = 56;
		int iLeft = ((iInc * -1) + 5);

		SetWindowPos(hTB_New, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Open, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_AddFiles, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Delete, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Extract, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		//SetWindowPos(hTB_View, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Info, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Config, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Find, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);
		SetWindowPos(hTB_Exit, NULL, (iLeft += iInc), 6, 50, 50, SWP_FRAMECHANGED);

		AlignText(hTB_New, GetDlgItem(hWnd, IDI_TB_NEW_TXT));
		AlignText(hTB_Open, GetDlgItem(hWnd, IDI_TB_OPEN_TXT));
		AlignText(hTB_AddFiles, GetDlgItem(hWnd, IDI_TB_ADDFILES_TXT));
		AlignText(hTB_Delete, GetDlgItem(hWnd, IDI_TB_DELETE_TXT));
		AlignText(hTB_Extract, GetDlgItem(hWnd, IDI_TB_EXTRACT_TXT));
		//AlignText(hTB_View, GetDlgItem(hWnd, IDI_TB_VIEW_TXT));
		AlignText(hTB_Info, GetDlgItem(hWnd, IDI_TB_INFO_TXT));
		AlignText(hTB_Config, GetDlgItem(hWnd, IDI_TB_CONFIG_TXT));
		AlignText(hTB_Find, GetDlgItem(hWnd, IDI_TB_FIND_TXT));
		AlignText(hTB_Exit, GetDlgItem(hWnd, IDI_TB_EXIT_TXT));

		//---------------------------------------------------------------------------------

        SendMessage(hFileList,
			(UINT)LVM_SETEXTENDEDLISTVIEWSTYLE,
			(WPARAM)0,
			(LPARAM)LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);

        ListView_SetTextColor(hFileList, RGB(0,0,100));

        LV_COLUMN MyLVColumb;

        memset(&MyLVColumb, 0, sizeof(LV_COLUMN));

        MyLVColumb.cx        = 200;
        MyLVColumb.pszText   = "Name";
        MyLVColumb.iSubItem  = 0;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 0, &MyLVColumb);

        MyLVColumb.cx        = 150;
        MyLVColumb.pszText   = "Type";
        MyLVColumb.iSubItem  = 1;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 1, &MyLVColumb);

        MyLVColumb.cx        = 125;
        MyLVColumb.pszText   = "Modified";
        MyLVColumb.iSubItem  = 2;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 2, &MyLVColumb);

        MyLVColumb.cx        = 65;
        MyLVColumb.pszText   = "Size";
        MyLVColumb.iSubItem  = 3;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_RIGHT;
        ListView_InsertColumn(hFileList, 3, &MyLVColumb);

        MyLVColumb.cx        = 50;
        MyLVColumb.pszText   = "Ratio";
        MyLVColumb.iSubItem  = 4;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 4, &MyLVColumb);

        MyLVColumb.cx        = 65;
        MyLVColumb.pszText   = "Packed";
        MyLVColumb.iSubItem  = 5;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_RIGHT;
        ListView_InsertColumn(hFileList, 5, &MyLVColumb);

        MyLVColumb.cx        = 75;
        MyLVColumb.pszText   = "CRC";
        MyLVColumb.iSubItem  = 6;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 6, &MyLVColumb);

        MyLVColumb.cx        = 75;
        MyLVColumb.pszText   = "Attributes";
        MyLVColumb.iSubItem  = 7;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 7, &MyLVColumb);

        MyLVColumb.cx        = 300;
        MyLVColumb.pszText   = "Path";
        MyLVColumb.iSubItem  = 8;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 8, &MyLVColumb);

        MyLVColumb.cx        = 0;
        MyLVColumb.pszText   = "Position";
        MyLVColumb.iSubItem  = 9;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(hFileList, 9, &MyLVColumb);

		//---------------------------------------------------------------------------------

		hImageList = ImageList_Create( GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLORDDB, 1, 100);
        ListView_SetImageList(hFileList, hImageList, LVSIL_SMALL);

		//---------------------------------------------------------------------------------

		hStatusBar = CreateStatusWindow(WS_CHILD|WS_VISIBLE, "Ready", hWnd, 1);

        int Widths[] = {200, -1};

        SendMessage(hStatusBar, (UINT)SB_SETPARTS, (WPARAM)2, (LPARAM)&Widths);

		//---------------------------------------------------------------------------------

		CenterWindow(hWnd);

        RECT rcHwnd;
        GetClientRect(hWnd, &rcHwnd);
        MoveWindow(hFileList, 0, 78, rcHwnd.right, rcHwnd.bottom - 100, TRUE);
        MoveWindow(hStatusBar, rcHwnd.right-20, rcHwnd.bottom-20, rcHwnd.right, rcHwnd.bottom, TRUE);
        MoveWindow(hHorizBar, 0, 2, rcHwnd.right, 2, TRUE);

		//---------------------------------------------------------------------------------

		if(gdwCurrentJobType == JOB_TYPE_EXTRACTALL)
		{
            if(strlen(gsWorkingOutput) == 0)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_EXTRACT), hWnd, ExtractDialog) == 1)
				{
					hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
					DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
				}
			}
			else{
				hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
				DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
			}
		}
		else if(gdwCurrentJobType == JOB_TYPE_READING)
        {
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), NULL, ReadingDialog) != 1)
            {
                ImageList_Destroy(hImageList);
                EndDialog(hWnd, 0);
                DestroyWindow(hWnd);
            }
        }
        else if(gdwCurrentJobType == JOB_TYPE_PACKING_DIR || gdwCurrentJobType == JOB_TYPE_PACKING_FIL) {
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), NULL, PackingDialog) != 1)
            {
                ImageList_Destroy(hImageList);
                EndDialog(hWnd, 0);
                DestroyWindow(hWnd);
            }
            else if(gbAutoClose == false) {
                // View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsWorkingOutput, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ImageList_Destroy(hImageList);
                    EndDialog(hWnd, 0);
                    DestroyWindow(hWnd);
                }
                gbArchiveOpen = true;
            }
        }
        else{
            ResumeThread(hWorker_Thread_Handle);
        }

		if(gbAutoClose == true)
		{
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);			
			return false;
		}

		//---------------------------------------------------------------------------------

		return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_DROPFILES)
    {
		//This seems like alot of wasted memory, but we need it all.
		bool bFirstFile = true;

		char sDir[MAX_PATH];
		char sDirTemp[MAX_PATH]; //Just some memory for AddFile() to use.
		char sDrive[MAX_PATH];
		char sExt[MAX_PATH];
		char sFile[MAX_PATH];
		char sFileName[MAX_PATH]; 
		char sFirstRoot[MAX_PATH];
		char sRoot[MAX_PATH];
		char szFileName[MAX_PATH];

		FilePack MyFilePack;
		HDROP hFilesInfo = (HDROP)wParam;

		int wIndex = 0;
		int wTotalFiles = DragQueryFile(hFilesInfo, -1, NULL, 0);

		//Save the name of the first sFile in szFileName, it will be overwritten.
		DragQueryFile(hFilesInfo, wIndex, (LPSTR)szFileName, MAX_PATH);

		if(wTotalFiles == 1)
		{
			_splitpath_s(szFileName, NULL, 0, NULL, 0, NULL, 0, sExt, sizeof(sExt));

			if(_strcmpi(sExt, ".PCE") == 0)
			{
				strcpy_s(gsArchiveName, sizeof(gsArchiveName), szFileName);

				// View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), hWnd, OpenPassDialog) != 1)
                {
                    return TRUE;
                }

                ShowWindow(hWnd, SW_HIDE);
                ListView_DeleteAllItems(hFileList);
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ListView_DeleteAllItems(hFileList);
                }
                ShowWindow(hWnd, SW_SHOW);

				return TRUE;
			}
		}

		if(gbArchiveOpen)
		{
			strcpy_s(gsWorkingOutput, sizeof(gsWorkingOutput), gsArchiveName);
		}
		else {
			if(MessageBox(hWnd, "Would you like to create a new archive?", gsTitleCaption, MB_YESNO|MB_ICONQUESTION) == IDNO)
			{
				return TRUE;
			}

            // Create a new archive from the directorys contents
            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
            {
                return TRUE;
            }
		}

		MyFilePack.Initialize(&AltFilePackage);

		int iRootLen = 0;

		while(wIndex < wTotalFiles)
        {
            DragQueryFile(hFilesInfo, wIndex, (LPSTR)szFileName, MAX_PATH);

			iRootLen = strlen(szFileName);

			while(iRootLen != 0)
			{
				if(szFileName[iRootLen] == '\\')
				{
					break;
				}
				iRootLen--;				
			}

			strcpy_s(sFirstRoot, sizeof(sFirstRoot), szFileName);
			sFirstRoot[iRootLen] = '\0';

			if(IsDirectory(szFileName))
			{
				bool bRecursive = true;
				//char sMsg[1024];

				//sprintf(sMsg, "Process all sub directorys that the folder contains?\r\n\"%s\"", szFileName);
				//int iMBResult = MessageBox(hWnd, sMsg, gsTitleCaption, MB_YESNOCANCEL|MB_ICONQUESTION);
				//if(iMBResult == IDCANCEL){
					//return TRUE;
				//}
				//else if(iMBResult == IDYES){
					bRecursive = true;
				//}
				//else if(iMBResult == IDNO){
					//bRecursive = false;
				//}


				MyFilePack.IndexDirectoryInternal(szFileName, iRootLen, true, NULL, &AltFilePackage);
			}
			else{
				_splitpath_s(szFileName,
					sDrive, sizeof(sDrive),
					sDir, sizeof(sDir),
					sFile, sizeof(sFile),
					sExt, sizeof(sExt));

				_makepath_s(sRoot, sizeof(sRoot), sDrive, sDir, NULL, NULL);

				if(bFirstFile)
				{
					strcpy_s(sFirstRoot, sizeof(sFirstRoot), sRoot);
					bFirstFile = false;
				}

				_makepath_s(sFileName, sizeof(sFileName), NULL, NULL, sFile, sExt);

				MyFilePack.AddFile(sRoot, iRootLen, sDirTemp, iRootLen, sFileName, &AltFilePackage);
			}

            wIndex++;
        }

		if(AltFilePackage.dwFileCount > 0)
		{
			gdwCurrentJobType = JOB_TYPE_ADDINGFILES;
			hWorker_Thread_Handle = CreateThread(NULL, 0, AddFiles_Worker_Thread, (LPVOID) sFirstRoot, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);

			// View an existing archive
			gdwCurrentJobType = JOB_TYPE_READING;
			hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsWorkingOutput, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
			{
				ImageList_Destroy(hImageList);
				EndDialog(hWnd, 0);
				DestroyWindow(hWnd);
			}
		}

		DragFinish(hFilesInfo);
		MyFilePack.FreeMemory(&AltFilePackage);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_LBUTTONUP)
	{
		if(MainDialog_hWnd == GetForegroundWindow())
		{
			if(IsMouseOverHwnd(hTB_New))
			{
				SendMessage(hWnd, WM_COMMAND, IDI_TB_NEW, 0);
				Float(hTB_New);
				return TRUE;
			}

			if(IsMouseOverHwnd(hTB_Open))
			{
				SendMessage(hWnd, WM_COMMAND, IDI_TB_OPEN, 0);
				Float(hTB_Open);
				return TRUE;
			}

			if(IsMouseOverHwnd(hTB_Info))
			{
				SendMessage(hWnd, WM_COMMAND, IDI_TB_INFO, 0);
				Float(hTB_Info);
				return TRUE;
			}

			if(IsMouseOverHwnd(hTB_Extract))
			{
				SendMessage(hWnd, WM_COMMAND, IDI_TB_EXTRACT, 0);
				Float(hTB_Extract);
				return TRUE;
			}

			if(IsMouseOverHwnd(hTB_Exit))
			{
				SendMessage(hWnd, WM_COMMAND, IDI_TB_EXIT, 0);
				Float(hTB_Exit);
				return TRUE;
			}
		}
	}

	//--------------------------------------------------------------------------
/*
    if(uMsg == WM_MOUSEMOVE)
	{
		OnMouseOver(hTB_New);
		OnMouseOver(hTB_Open);
		OnMouseOver(hTB_AddFiles);
		OnMouseOver(hTB_Delete);
		OnMouseOver(hTB_Extract);
		OnMouseOver(hTB_View);
		OnMouseOver(hTB_Info);
		OnMouseOver(hTB_Config);
		OnMouseOver(hTB_Find);
		OnMouseOver(hTB_Exit);
	}
*/
    //--------------------------------------------------------------------------

    if(uMsg == WM_SIZE)
    {
		static int iMinWidth = 520;
		static int iMinHeight = 353;

		bool bUnderMin = false;

		int nWidth = LOWORD(lParam);
        int nHeight = HIWORD(lParam);

		
		RECT rcHwnd;
		GetWindowRect(hWnd, &rcHwnd);

		int iSetWidth = rcHwnd.right - rcHwnd.left;
		int iSetHeight = rcHwnd.bottom - rcHwnd.top;

		if(iSetWidth < iMinWidth)
		{
			iSetWidth = iMinWidth;
			bUnderMin = true;
		}

		if(iSetHeight < iMinHeight)
		{
			iSetHeight = iMinHeight;
			bUnderMin = true;
		}

		if(bUnderMin)
		{
			SetWindowPos(hWnd, NULL, 0, 0, iSetWidth, iSetHeight, SWP_NOMOVE | SWP_NOACTIVATE);
			return TRUE;
		}
		else{
			MoveWindow(hFileList, 0, 78, nWidth, nHeight - 100, TRUE);
			MoveWindow(hStatusBar, nWidth-20, nHeight-20, nWidth, nHeight, TRUE);
	        MoveWindow(hHorizBar, 0, 2, nWidth, 2, TRUE);
		}

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
		if(wParam == IDI_TB_INFO)
        {
			if(ListView_GetSelectedCount(hFileList) == 1)
			{
				DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_FILEINFO), hWnd, FileInfoDialog);
			}
			return TRUE;
		}
		
		if(wParam == ID_HELP_ENTERREGISTRATIONCODE)
        {
			if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_REGISTRATION), hWnd, RegistrationDialog) == 1)
			{
			
			}
			return TRUE;
		}
		
		
		if(wParam == ID_FILE_FNEW || wParam == IDI_TB_NEW)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            gbArchiveOpen = false;

            gdwCurrentJobType = 0;

            memset(gsArchiveName, 0, sizeof(gsArchiveName));
            memset(gsLastExtractLocation, 0, sizeof(gsLastExtractLocation));
            memset(gsWorkingOutput, 0, sizeof(gsWorkingOutput));

            ListView_DeleteAllItems(hFileList);

            return TRUE;
        }

        if(wParam == ID_FILE_FOPEN || wParam == IDI_TB_OPEN)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            char *DefaultExtension = NULL;
            char *Filters = "Project-Epsilon-Files\0*.PCE\0All-Files\0*.*\0\0";
            char InitialDirectory[MAX_PATH + 1];

            GetCurrentDirectory(MAX_PATH, InitialDirectory);

            if(OSFileDialog(hWnd, gsArchiveName, ".PCE", "Select an archive to open", Filters, InitialDirectory, OFD, OFN_EXPLORER + OFN_LONGNAMES + OFN_PATHMUSTEXIST))
            {
                // View an existing archive
                gdwCurrentJobType = JOB_TYPE_READING;
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), hWnd, OpenPassDialog) != 1)
                {
                    return TRUE;
                }

                ShowWindow(hWnd, SW_HIDE);
                ListView_DeleteAllItems(hFileList);
                hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_READING), hWnd, ReadingDialog) != 1)
                {
                    ListView_DeleteAllItems(hFileList);
                }
                ShowWindow(hWnd, SW_SHOW);
            }

            return TRUE;
        }

		/*
        if(wParam == IDM_FIND)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            int Value = ListView_GetSelectedCount(hFileList);

            int ItemPos = -1;
            while( (ItemPos = ListView_GetNextItem(hFileList, ItemPos, LVNI_SELECTED)) != -1)
            {
                char sFileName[255 + 1];
                char sFullFileName[255 + 1];
                char Path[255 + 1];

                ListView_GetItemText(hFileList, ItemPos, 0, sFileName, 255);
                ListView_GetItemText(hFileList, ItemPos, 8, Path, 255);

                _makepath(sFullFileName, NULL, Path, sFileName, NULL);

                MessageBox(hWnd, sFullFileName, Path, 0);
            }

            return TRUE;
        }
		*/

		if(wParam == IDI_TB_EXTRACT)
		{
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_EXTRACT), hWnd, ExtractDialog) == 1)
            {
                hWorker_Thread_Handle = CreateThread(NULL, 0, ExtractEntireArchive_Worker_Thread, (LPVOID) gsArchiveName, CREATE_SUSPENDED, &dwWorker_Thread_ID);
                DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PACKING), hWnd, PackingDialog);
            }
			return TRUE;
		}

		if(wParam == ID_FILE_EXIT || wParam == IDI_TB_EXIT)
        {
            PlaySound(MAKEINTRESOURCE(IDR_TICKWAVE), ghAppInstance, SND_ASYNC|SND_RESOURCE);

            ImageList_Destroy(hImageList);
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);
            return TRUE;
        }

        if(wParam == ID_HELP_ABOUT)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
			return TRUE;
		}

		return FALSE;
    }

	//--------------------------------------------------------------------------
	/*
	if(uMsg == WM_MOUSEMOVE)
	{
		POINT p;

        if (!bDragging)
		{
            return TRUE;
		}

        p.x = LOWORD(lParam);
        p.y = HIWORD(lParam);

        ClientToScreen(hWnd, &p);
        ImageList_DragMove(p.x, p.y);

		return TRUE;
	}
	*/
    //--------------------------------------------------------------------------
	/*
   	if(uMsg == WM_LBUTTONUP)
	{
		// End the drag-and-drop process
        bDragging = FALSE;
        ImageList_DragLeave(hFileList);
        ImageList_EndDrag();
        ImageList_Destroy(hDragImageList);

        ReleaseCapture();

        //// Determine the dropped item
        //lvhti.pt.x = LOWORD(lParam);
        //lvhti.pt.y = HIWORD(lParam);
        //ClientToScreen(hWndMain, &lvhti.pt);
        //ScreenToClient(hFileList, &lvhti.pt);
        //ListView_HitTest(hFileList, &lvhti);

        //// Out of the ListView?
        //if (lvhti.iItem == -1)
        //    break;

        //// Not in an item?
        //if ((lvhti.flags & LVHT_ONITEMLABEL == 0) && (lvhti.flags & LVHT_ONITEMSTATEICON == 0))
        //    break;

        //// Dropped item is selected?
        //lvi.iItem = lvhti.iItem;
        //lvi.iSubItem = 0;
        //lvi.mask = LVIF_STATE;
        //lvi.stateMask = LVIS_SELECTED;
        //ListView_GetItem(hFileList, &lvi);

        //if (lvi.state & LVIS_SELECTED)
        //    break;

        //// Rearrange the items
        //iPos = ListView_GetNextItem(hFileList, -1, LVNI_SELECTED);
        //while (iPos != -1) {
        //    // First, copy one item
        //    lvi.iItem = iPos;
        //    lvi.iSubItem = 0;
        //    lvi.cchTextMax = MAX_TARGET_LEN;
        //    lvi.pszText = buf;
        //    lvi.stateMask = ~LVIS_SELECTED;
        //    lvi.mask = LVIF_STATE | LVIF_IMAGE 
        //                | LVIF_INDENT | LVIF_PARAM | LVIF_TEXT;
        //    ListView_GetItem(hFileList, &lvi);
        //    lvi.iItem = lvhti.iItem;
        //    // Insert the main item
        //    iRet = ListView_InsertItem(hFileList, &lvi);
        //    if (lvi.iItem < iPos)
        //        lvhti.iItem++;
        //    if (iRet <= iPos)
        //        iPos++;
        //    // Set the subitem text
        //    for (i = 1; i < JOB_WIN_COLUMN_NUM; i++) {
        //        ListView_GetItemText(hFileList, iPos, 
        //                       i, buf, MAX_TARGET_LEN);
        //        ListView_SetItemText(hFileList, iRet, i, buf);
        //    }
        //    // Delete from original position
        //    ListView_DeleteItem(hFileList, iPos);
        //    iPos = ListView_GetNextItem(hFileList, -1, LVNI_SELECTED);
        //}

        return true;
	}
	*/

	//--------------------------------------------------------------------------

	if(uMsg == WM_NOTIFY)
    {
        LPNMHDR lpnmhdr = (LPNMHDR)lParam;

		if (lpnmhdr->hwndFrom == hFileList)
        {
            int iSortSubItem = 0;
            LVCOLUMN MyLVColumn;
            NMLISTVIEW  *pNMLV;
            SORTDATA SortData;
			int iIndex = 0;
            char ColName[64];

            if(lpnmhdr->code == NM_DBLCLK)
            {
                MsgBox("Not Implemented.");

				iIndex = ListView_GetNextItem(hFileList, -1, LVNI_SELECTED);
                MessageBox(hWnd, IntChar(iIndex), gsTitleCaption, 0);
			}
/*
			else if(lpnmhdr->code == LVN_BEGINDRAG)
			{
                //MsgBox("Not Implemented.");

				POINT p;
				POINT pt;

				p.x = 8;
				p.y = 8;

				HIMAGELIST hOneImageList;
				HIMAGELIST hTempImageList;

				IMAGEINFO imf;
				int iHeight = 0;

				//Ok, now we create a drag-image for all selected items.
				bFirst = TRUE;
				int iPos = ListView_GetNextItem(hFileList, -1, LVNI_SELECTED);

				while (iPos != -1)
				{
					if (bFirst)
					{
						// For the first selected item, we simply create a single-line drag image.
						hDragImageList = ListView_CreateDragImage(hFileList, iPos, &p);
						ImageList_GetImageInfo(hDragImageList, 0, &imf);
						iHeight = imf.rcImage.bottom;
						bFirst = FALSE;
					}
					else{
						//For the rest selected items, we create a single-line drag image,
						// then append it to the bottom of the complete drag image.
						hOneImageList = ListView_CreateDragImage(hFileList, iPos, &p);
						hTempImageList = ImageList_Merge(hDragImageList, 0, hOneImageList, 0, 0, iHeight);
						ImageList_Destroy(hDragImageList);
						ImageList_Destroy(hOneImageList);
						hDragImageList = hTempImageList;
						ImageList_GetImageInfo(hDragImageList, 0, &imf);
						iHeight = imf.rcImage.bottom;
					}
					iPos = ListView_GetNextItem(hFileList, iPos, LVNI_SELECTED);
				}

				// Now we can initialize then start the drag action
				ImageList_BeginDrag(hDragImageList, 0, 0, 0);

				pt = ((NM_LISTVIEW*) ((LPNMHDR)lParam))->ptAction;
				ClientToScreen(hFileList, &pt);

				ImageList_DragEnter(GetDesktopWindow(), pt.x, pt.y);

				bDragging = TRUE;

				// Don't forget to capture the mouse
				SetCapture(hWnd);
			}
			*/
			else if(lpnmhdr->code == LVN_COLUMNCLICK)
			{
                pNMLV = (NMLISTVIEW *)lParam;
                iSortSubItem = pNMLV->iSubItem;

                memset(&SortData, 0, sizeof(SortData));
                memset(&MyLVColumn, 0, sizeof(&MyLVColumn));

                if(iSortCol == iSortSubItem)
                {
                    if(iSortUpOrDown == SORT_UP)
					{
                        iSortUpOrDown = SORT_DOWN;
					}
                    else iSortUpOrDown = SORT_UP;
                }
                else {
                    iSortCol = iSortSubItem;
                    iSortUpOrDown = SORT_UP;
                }

                SortData.hwndList = hFileList;
                SortData.isortSubItem = iSortCol;
                SortData.iUPDOWN = iSortUpOrDown;

                MyLVColumn.mask = LVCF_TEXT;
                MyLVColumn.pszText = ColName;
                MyLVColumn.cchTextMax = sizeof(ColName);

                if(ListView_GetColumn(hFileList, iSortSubItem, &MyLVColumn))
                {
                    if(_strcmpi(ColName, "Name") == 0)
                        SortData.iColType = COL_STRING;
                    else if(_strcmpi(ColName, "Type") == 0)
                        SortData.iColType = COL_STRING;
                    else if(_strcmpi(ColName, "Modified") == 0)
                        SortData.iColType = COL_DATE;
                    else if(_strcmpi(ColName, "Size") == 0)
                        SortData.iColType = COL_INTEGER;
                    else if(_strcmpi(ColName, "Packed") == 0)
                        SortData.iColType = COL_INTEGER;
                    else if(_strcmpi(ColName, "Ratio") == 0)
                        SortData.iColType = COL_DOUBLE;
                    else if(_strcmpi(ColName, "CRC") == 0)
                        SortData.iColType = COL_STRING;
                    else if(_strcmpi(ColName, "Attributes") == 0)
                        SortData.iColType = COL_STRING;
                    else if(_strcmpi(ColName, "Path") == 0)
                        SortData.iColType = COL_STRING;
                    else if(_strcmpi(ColName, "Position") == 0)
                        SortData.iColType = COL_INTEGER;
                    else SortData.iColType = 0;

                    if(SortData.iColType == COL_DATE)
                    {
                        ListView_SortItems(hFileList, CompList, (LPARAM)&SortData);
                    }
                    else if(SortData.iColType != 0)
                    {
                        ListView_SortItemsEx(hFileList, CompListEx, (LPARAM)&SortData);
                    }
				}
			}
        }
        return TRUE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        ImageList_Destroy(hImageList);
        EndDialog(hWnd,0);
        DestroyWindow(hWnd);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

