#ifndef _PersonDLG_CPP
#define _PersonDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Debug.H"
#include "../Source/Entry.H"
#include "../Source/Routines.H"

#include "../Dialogs/PersonDlg.H"
#include "../Dialogs/SecurityDialog.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND hPersonDialog = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK PersonDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

	static HWND hFirstName = NULL;
	static HWND hMiddleName = NULL;
	static HWND hLastName = NULL;
	static HWND hAddress1 = NULL;
	static HWND hAddress2 = NULL;
	static HWND hCity = NULL;
	static HWND hState = NULL;
	static HWND hZipCode = NULL;
	static HWND hCountry = NULL;
	static HWND hHomePhone = NULL;
	static HWND hWorkPhone = NULL;
	static HWND hCellPhone = NULL;
	static HWND hFaxNumber = NULL;
	static HWND hEmailAddress = NULL;
	static HWND hComments = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        hPersonDialog = hWnd;

        HMENU hSysMenu_hMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(hSysMenu_hMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(hSysMenu_hMenu, MF_STRING, PERSONDIALOG_MENU_ABOUT, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)));

		hFirstName      = GetDlgItem(hWnd, IDC_FIRSTNAME);
		hMiddleName     = GetDlgItem(hWnd, IDC_MIDDLENAME);            
		hLastName       = GetDlgItem(hWnd, IDC_LASTNAME);              
		hAddress1       = GetDlgItem(hWnd, IDC_ADDRESS1);              
		hAddress2       = GetDlgItem(hWnd, IDC_ADDRESS2);              
		hCity           = GetDlgItem(hWnd, IDC_CITY);                  
		hState          = GetDlgItem(hWnd, IDC_STATE);                 
		hZipCode        = GetDlgItem(hWnd, IDC_ZIPCODE);               
		hCountry        = GetDlgItem(hWnd, IDC_COUNTRY);               
		hHomePhone      = GetDlgItem(hWnd, IDC_HOMEPHONE);             
		hWorkPhone      = GetDlgItem(hWnd, IDC_WORKPHONE);             
		hCellPhone      = GetDlgItem(hWnd, IDC_CELLPHONE);             
		hFaxNumber      = GetDlgItem(hWnd, IDC_FAXNUMBER);             
		hEmailAddress   = GetDlgItem(hWnd, IDC_EMAILADDRESS);          
		hComments       = GetDlgItem(hWnd, IDC_COMMENTS);

		CenterWindow(hWnd);

		if(strlen(gsOpenFilename) > 0)
		{
			char sFirstName[1024];
			char sMiddleName[1024];
			char sLastName[1024];
			char sAddress1[1024];
			char sAddress2[1024];
			char sCity[1024];
			char sState[1024];
			char sZipCode[1024];
			char sCountry[1024];
			char sHomePhone[1024];
			char sWorkPhone[1024];
			char sCellPhone[1024];
			char sFaxNumber[1024];
			char sEmailAddress[1024];
			char sComments[1024];

			int iCertAttribs = 0;
			int iCryptAlgo = 0;
			int iCertKeySz = 128;

			if(ReadCert(hWnd, "C:\\Key.txt", "123456789", &iCertAttribs, &iCryptAlgo,
				&iCertKeySz, sFirstName, sMiddleName, sLastName, sAddress1, sAddress2,
				sCity, sState, sZipCode, sCountry, sHomePhone, sWorkPhone, sCellPhone,
				sFaxNumber, sEmailAddress, sComments))
			{
				Set_Text(hFirstName, sFirstName);
				Set_Text(hMiddleName, sMiddleName);
				Set_Text(hLastName, sLastName);
				Set_Text(hAddress1, sAddress1);
				Set_Text(hAddress2, sAddress2);
				Set_Text(hCity, sCity);
				Set_Text(hState, sState);
				Set_Text(hZipCode, sZipCode);
				Set_Text(hCountry, sCountry);
				Set_Text(hHomePhone, sHomePhone);
				Set_Text(hWorkPhone, sWorkPhone);
				Set_Text(hCellPhone, sCellPhone);
				Set_Text(hFaxNumber, sFaxNumber);
				Set_Text(hEmailAddress, sEmailAddress);
				Set_Text(hComments, sComments);
			}

			EnableWindow(GetDlgItem(hWnd, IDC_CREATE), FALSE);
			SendMessage(hFirstName, EM_SETREADONLY, 1, 0);
			SendMessage(hMiddleName, EM_SETREADONLY, 1, 0);
			SendMessage(hLastName, EM_SETREADONLY, 1, 0);
			SendMessage(hAddress1, EM_SETREADONLY, 1, 0);
			SendMessage(hAddress2, EM_SETREADONLY, 1, 0);
			SendMessage(hCity, EM_SETREADONLY, 1, 0);
			SendMessage(hState, EM_SETREADONLY, 1, 0);
			SendMessage(hZipCode, EM_SETREADONLY, 1, 0);
			SendMessage(hCountry, EM_SETREADONLY, 1, 0);
			SendMessage(hHomePhone, EM_SETREADONLY, 1, 0);
			SendMessage(hWorkPhone, EM_SETREADONLY, 1, 0);
			SendMessage(hCellPhone, EM_SETREADONLY, 1, 0);
			SendMessage(hFaxNumber, EM_SETREADONLY, 1, 0);
			SendMessage(hEmailAddress, EM_SETREADONLY, 1, 0);
			SendMessage(hComments, EM_SETREADONLY, 1, 0);
			return FALSE;
		}

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE.
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
        if(wParam == IDC_CREATE && strlen(gsOpenFilename) == 0)
        {
		    if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_SECURITY), hWnd, SecurityDialog) != 1)
			{
				return TRUE;
			}

			char sFirstName[1024];
			char sMiddleName[1024];
			char sLastName[1024];
			char sAddress1[1024];
			char sAddress2[1024];
			char sCity[1024];
			char sState[1024];
			char sZipCode[1024];
			char sCountry[1024];
			char sHomePhone[1024];
			char sWorkPhone[1024];
			char sCellPhone[1024];
			char sFaxNumber[1024];
			char sEmailAddress[1024];
			char sComments[1024];

			if(Get_TextEx(hFirstName, sFirstName, sizeof(sFirstName)) >= sizeof(sFirstName)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hMiddleName, sMiddleName, sizeof(sMiddleName)) >= sizeof(sMiddleName)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hLastName, sLastName, sizeof(sLastName)) >= sizeof(sLastName)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hAddress1, sAddress1, sizeof(sAddress1)) >= sizeof(sAddress1)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hAddress2, sAddress2, sizeof(sAddress2)) >= sizeof(sAddress2)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hCity, sCity, sizeof(sCity)) >= sizeof(sCity)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hState, sState, sizeof(sState)) >= sizeof(sState)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hZipCode, sZipCode, sizeof(sZipCode)) >= sizeof(sZipCode)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hCountry, sCountry, sizeof(sCountry)) >= sizeof(sCountry)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hHomePhone, sHomePhone, sizeof(sHomePhone)) >= sizeof(sHomePhone)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hWorkPhone, sWorkPhone, sizeof(sWorkPhone)) >= sizeof(sWorkPhone)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hCellPhone, sCellPhone, sizeof(sCellPhone)) >= sizeof(sCellPhone)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hFaxNumber, sFaxNumber, sizeof(sFaxNumber)) >= sizeof(sFaxNumber)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hEmailAddress , sEmailAddress, sizeof(sEmailAddress)) >= sizeof(sEmailAddress)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}
			else if(Get_TextEx(hComments, sComments, sizeof(sComments)) >= sizeof(sComments)){
				MessageBox(hWnd, "Invalid \"\" entry", gsTitleCaption, MB_ICONINFORMATION);
				return TRUE;
			}

			WriteCert(hWnd, "C:\\Key.txt", "123456789", giCertAttribs, giCryptAlgo,
				giCertKeySz, sFirstName, sMiddleName, sLastName, sAddress1, sAddress2,
				sCity, sState, sZipCode, sCountry, sHomePhone, sWorkPhone, sCellPhone,
				sFaxNumber, sEmailAddress, sComments);

			MessageBox(hWnd, "Encryption certificate successfully created.", gsTitleCaption, MB_ICONINFORMATION);

            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);

			hPersonDialog = NULL;

            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        //- Any painting should be done here.

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) //- Received a system menu message.
    {
        if(LOWORD(wParam) == PERSONDIALOG_MENU_ABOUT) //- About.
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE) //- Received close message.
    {
        EndDialog(hWnd,0);
        DestroyWindow(hWnd);

		hPersonDialog = NULL;

        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

