#ifndef _SecurityDialog_CPP
#define _SecurityDialog_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Debug.H"
#include "../Source/Entry.H"
#include "../Source/Routines.H"

#include "../Dialogs/PersonDlg.H"
#include "../Dialogs/SecurityDialog.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND hSecurityDialog = NULL;

int giCertKeySz = 0;
int giCertAttribs = 0;
int giCryptAlgo = 0;
int giCompressLevel = 0;

char gsCertPWD[MAX_PASSWORDSZ];

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK SecurityDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HWND Password1_hWnd = NULL;
    static HWND Password2_hWnd = NULL;
    static HWND PasswordBits_hWnd = NULL;
    static HWND CompressLevel_hWnd = NULL;
    static HWND EncryptAlgo_hWnd = NULL;
    static HWND KeyGenSlider_hWnd = NULL;
    static HWND CertPWDBlider_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        hSecurityDialog = hWnd;

        HMENU hSysMenu_hMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(hSysMenu_hMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(hSysMenu_hMenu, MF_STRING, SECURITYDIALOG_MENU_ABOUT, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)));

        Password1_hWnd = GetDlgItem(hWnd, IDC_PASSWORD1);
        Password2_hWnd = GetDlgItem(hWnd, IDC_PASSWORD2);
        CompressLevel_hWnd = GetDlgItem(hWnd, IDC_COMPRESSLEVEL);
        EncryptAlgo_hWnd = GetDlgItem(hWnd, IDC_ENCRYPTALGO);
		PasswordBits_hWnd = GetDlgItem(hWnd, IDC_PASSWORDBITS2);
		KeyGenSlider_hWnd = GetDlgItem(hWnd, IDC_KEYGENSZ);
		CertPWDBlider_hWnd = GetDlgItem(hWnd, IDC_CERTPWDBITS);

		Set_Text(Password1_hWnd, "123456789");
		Set_Text(Password2_hWnd, "123456789");

		SendMessage(Password1_hWnd, EM_LIMITTEXT, MAX_PASSWORDSZ, 0 );
        SendMessage(Password2_hWnd, EM_LIMITTEXT, MAX_PASSWORDSZ, 0 );

		SendMessage(KeyGenSlider_hWnd, TBM_SETRANGEMIN, TRUE, 0);
		SendMessage(KeyGenSlider_hWnd, TBM_SETRANGEMAX, TRUE, 1048576 * 100);
		SendMessage(KeyGenSlider_hWnd, TBM_SETPOS, TRUE, 8);
		SendMessage(hWnd, 276, 0, 0);

        int iIndex = 0;
		char sDfltStr[1024];
		DWORD dwDfltStrSz = 0;

		//-----------------------------------------------------------------------------------------
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"None");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Very Low (Default)");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Low");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Moderate");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"High");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Very High (Slowest)");

   	    //Set the default Compression Method.
		dwDfltStrSz = sizeof(sDfltStr);
		memset(sDfltStr, 0, dwDfltStrSz);
		if(Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltCompressLevel", sDfltStr, dwDfltStrSz))
			iIndex = SendMessage(CompressLevel_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) sDfltStr);
		else iIndex = SendMessage(CompressLevel_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) "None");
		SendMessage(CompressLevel_hWnd, (UINT)CB_SETCURSEL, (WPARAM)iIndex, (LPARAM)NULL);

		//-----------------------------------------------------------------------------------------
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"AES Algorithm (Rijndael)");
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"NASCCL");
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"BlowFish");
        //SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Simple Cipher");

	    //Set the default Encryption Algorithm.
		dwDfltStrSz = sizeof(sDfltStr);
		memset(sDfltStr, 0, dwDfltStrSz);
		if(Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltEncryptAlgo", sDfltStr, dwDfltStrSz))
			iIndex = SendMessage(EncryptAlgo_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) sDfltStr);
		else iIndex = SendMessage(EncryptAlgo_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) "Simple Cipher");
		SendMessage(EncryptAlgo_hWnd, (UINT)CB_SETCURSEL, (WPARAM)iIndex, (LPARAM)NULL);

		CenterWindow(hWnd);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE.
    }

	if(uMsg == 276)
	{
		int iPDWDLen = SendMessage(KeyGenSlider_hWnd, TBM_GETPOS, 0, 0);

		char lsTemp0[64];
		char lsTemp1[64];

		sprintf_s(lsTemp0, sizeof(lsTemp0), " (%s Bits)", FormatInteger(lsTemp1, (iPDWDLen * 8)));

		Set_Text(CertPWDBlider_hWnd, lsTemp0);
	}

	//--------------------------------------------------------------------------

    if(uMsg == 307) // Key Down
    {
		HWND hCurrentFocus = GetFocus();

		if(hCurrentFocus == Password1_hWnd)
		{
			char lsTemp0[64];
			char lsTemp1[64];
			int iPDWDLen = SendMessage(Password1_hWnd, WM_GETTEXTLENGTH, 0, 0);
			sprintf_s(lsTemp0, sizeof(lsTemp0), " (%s Bits)", FormatInteger(lsTemp1, (iPDWDLen * 8)));
			Set_Text(PasswordBits_hWnd, lsTemp0);
		}
		else if(hCurrentFocus == Password2_hWnd)
		{
			char lsTemp0[64];
			char lsTemp1[64];
			int iPDWDLen = SendMessage(Password2_hWnd, WM_GETTEXTLENGTH, 0, 0);
			sprintf_s(lsTemp0, sizeof(lsTemp0), " (%s Bits)", FormatInteger(lsTemp1, (iPDWDLen * 8)));
			Set_Text(PasswordBits_hWnd, lsTemp0);
		}
    }

	//--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
        if(wParam == IDC_OKBUTTON)
        {
			char lsCompressLevel[100];
			char lsEncryptionMethod[100];

			if(Get_TextEx(Password1_hWnd, gsCertPWD, sizeof(gsCertPWD)) > sizeof(gsCertPWD))
			{
				return TRUE;;
			}

			if((giCertKeySz = SendMessage(KeyGenSlider_hWnd, TBM_GETPOS, 0, 0)) < 8)
			{
				return TRUE;
			}

			//-----------------------------------------------------------------------------------------
            Get_TextEx(CompressLevel_hWnd, lsCompressLevel, 32);
            if(_strcmpi(lsCompressLevel, "None") != 0)
            {
                if(_strcmpi(lsCompressLevel, "Very Low (Default)") == 0)
                    giCompressLevel = 0;
                else if(_strcmpi(lsCompressLevel, "Low") == 0)
                    giCompressLevel = 1;
                else if(_strcmpi(lsCompressLevel, "Moderate") == 0)
                    giCompressLevel = 2;
                else if(_strcmpi(lsCompressLevel, "High") == 0)
                    giCompressLevel = 3;
                else if(_strcmpi(lsCompressLevel, "Very High (Slowest)") == 0)
                    giCompressLevel = 4;
            }

			//-----------------------------------------------------------------------------------------
            Get_TextEx(EncryptAlgo_hWnd, lsEncryptionMethod, 32);
			if(_strcmpi(lsEncryptionMethod, "None") != 0)
            {
                if(_strcmpi(lsEncryptionMethod, "NASCCL") == 0)
				{
                    giCryptAlgo = CRYPT_ALGO_NASCCL;
				}
				else if(_strcmpi(lsEncryptionMethod, "AES Algorithm (Rijndael)") == 0){

                    giCryptAlgo = CRYPT_ALGO_RIJNDAEL;
				}
				else if(_strcmpi(lsEncryptionMethod, "BlowFish") == 0){
                    giCryptAlgo = CRYPT_ALGO_BLOWFISH;
				}
            }

			
			EndDialog(hWnd, 1);
			hSecurityDialog = NULL;

            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            EndDialog(hWnd, 0);
            DestroyWindow(hWnd);

			hSecurityDialog = NULL;

            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        //- Any painting should be done here.

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) //- Received a system menu message.
    {
        if(LOWORD(wParam) == SECURITYDIALOG_MENU_ABOUT) //- About.
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE) //- Received close message.
    {
        EndDialog(hWnd,0);
        DestroyWindow(hWnd);

		hSecurityDialog = NULL;

        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

