#ifndef _FolderTree_H
#define _FolderTree_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define LOAD_TREE_ITEMS_INCREMENT 10

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class FolderTree {
    public:
        BOOL FolderTree::FolderTreeHandler(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
        bool InitFolderTree(HWND hTreeHandle, HWND hButtonHandle, HWND hEditBohWnd);
        bool UnInitFolderTree(void);
        bool SelectPath(const char *sINPath);
		BOOL DeleteAllItems(void);
        bool GetDesktopFolderPath(char *sOUTDesktopPath);

    private:
        char **sLoadedList;

        char gsExtractLocation[MAX_PATH];

        HIMAGELIST hImageList;

        HWND lhButtonHandle;
        HWND lhEditBohWnd;
        HWND lhTreeHandle;

        int iLoadedItems;
        int iMaxLoadedItems;

        bool CreateTreeImageList(void);
        bool FreeAlreadyLoaded(void);
        BOOL GetTreeItemText(HTREEITEM htItem, char *sOUTText);
		bool IndexDirectoryForSubItem(HTREEITEM hSubLeaf, const char *sINFolder, bool bIndexTwoDeep, bool bIgnoreAlreadyLoaded);
        bool InitAlreadyLoaded(void);
        bool IsAlreadyLoaded(const char *sINFolder);
        bool PopBrowseTree(void);
        HTREEITEM AddTreeViewItem(HTREEITEM hParent, char *sINText, int iImage, int iSelImage);
		void FolderTree::SetEditCursorToEnd(void);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

