#ifndef _PACKAGE_H
#define _PACKAGE_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "IndexDir.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//For extra header information, see the "Project Epsilon Header Makeup.doc" file.

#define APP_IDENTITY           "Project Epsilon"
#define COMP_VERSION           "Project Epsilon Compatibility Version 000100x"
#define THUMB_PRINT_SZ         128
#define RESERVE_HEADER_SZ      864
#define FILECOUNTPOS           sizeof(long) + sizeof(DWORD) + sizeof(long) + sizeof(int) + \
									sizeof(int) + sizeof(DWORD) + sizeof(DWORD) + \
									THUMB_PRINT_SZ+RESERVE_HEADER_SZ

#define DEFAULT_BUF_SZ         524288  // 1/2 MB Buffer.
//#define DEFAULT_BUF_S        1048576 // 1 MB Buffer.
//#define DEFAULT_BUF_SZ       10240   // 10 KB Buffer.
#define EXTRA_SIZE             (512 * 1024)
#define HASHKEYLEN             512
#define CHECKSUMLEN            1024
#define HARDCHECKSUMBASE       9841478 //Just a random number.

#define CRYPT_ALGO_NASCCL      0
#define CRYPT_ALGO_RIJNDAEL    1
#define CRYPT_ALGO_BLOWFISH    2

#define BLOWFISH_KEY_LEN       56
#define RIJNDAEL_KEY_LEN       32
#define SIMPLE_KEY_LEN         1024

#define ATTRIB_COMPRESSION     0x0001
#define ATTRIB_DATETIME        0x0002
#define ATTRIB_CRCCHECK        0x0004
#define ATTRIB_SAVEPATHS       0x0010
#define ATTRIB_ATTRIBUTES      0x0020

#define ATTRIB_ADDFILES        0x0001 //Add files to the archive, otherwise we will replace the existing archive.
#define ATTRIB_USEALTFILEPACK  0x0002 //Use the contents of the passed lpMyFilePack structure.

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _MakePackage_Params{
	char *sSrcFolder;
	char *sTarName;
	char *sRawKey;
	int iRawKeyLen;
	int iPkgAttribs;
	int iOptions;
} MKPKGPARAM, *LPMKPKGPARAM;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool BreakPackage(char *SrcName, char *TarFolder, char *sRawKey, int RawKeyLen);
bool MakePackage(LPMKPKGPARAM lpMyMkPkgParam);
bool PopGrid(char *SrcName, char *sRawKey, int RawKeyLen);

DWORD WINAPI CreateNewDirArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI ViewExisting_Worker_Thread(LPVOID xData);
DWORD WINAPI ExtractEntireArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI CreateFileArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI AddFiles_Worker_Thread(LPVOID xData);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern DWORD dwPackageProgress;
extern float fFileProgress;
extern bool gbOverwriteDlft;

extern DWORD dwWorker_Thread_ID;
extern HANDLE hWorker_Thread_Handle;

extern FILEPACKAGE AltFilePackage;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
